/// <reference types="react" />
import { RouteProps, useHistory } from 'react-router-dom';
import { RouteSlot } from './slot-router';
declare type History = ReturnType<typeof useHistory>;
export declare class ReactRouterUI {
    /**
     * route slot.
     */
    private routeSlot;
    constructor(
    /**
     * route slot.
     */
    routeSlot: RouteSlot);
    private routerHistory?;
    link(): void;
    /**
     * render all slot routes.
     */
    renderRoutes(routes: RouteProps[]): JSX.Element;
    /** sets the routing engine for navigation methods (internal method) */
    setRouter: (routerHistory: History) => void;
    /**
     * register a new route.
     */
    register(route: RouteProps): this;
    /**
     * change browser location
     */
    navigateTo: (path: string) => void;
    static slots: ((registerFn: () => string) => import("@teambit/harmony").SlotRegistry<RouteProps>)[];
    static runtime: import("@teambit/harmony").RuntimeDefinition;
    static provider(deps: any, config: any, [routeSlot]: [RouteSlot]): Promise<ReactRouterUI>;
}
export {};
